using Fluent;
using TMPro;
using UnityEngine.UI;

/// <summary>
/// This is an advanced example that show how you can return a fluent node from a method
/// </summary>
public class Conversation5b : MyFluentDialogue
{
    private int numCorrect = 0;

    FluentNode CreateAddQuestion(int a, int b)
    {
        FluentNode correctOption =
            Option((a + b).ToString()) *
                Hide() *
                Yell("Correct!") *
                Do(() => numCorrect += 1) *
                End();

        FluentNode incorrectOption =
            Option((a + b + UnityEngine.Random.Range(1, 2)).ToString()) *
                Hide() *
                Yell("Incorrect") *
                End();

        // Randomly swap answers so that the first answer isn't always the correct answer
        bool swap = UnityEngine.Random.value > 0.5f;

        //
        FluentNode ret =
            Options
            (
                Show() *
                Write(0, $"What is {a} + {b} ?") *
                (swap ? incorrectOption * correctOption : correctOption * incorrectOption)
            );

        return ret;
    }

    public override FluentNode Create()
    {
        return
            Do(() => numCorrect = 0) *
            CreateAddQuestion(1, 1) *
            CreateAddQuestion(3, 5) *
            Yell(Eval(() => "You have " + numCorrect + " correct"));
    }
}
